package intsort;

public class Sort10 implements Sort {

  static void swap(int[] a, int i, int j) {
    int tmp = a[i];
    a[i] = a[j];
    a[j] = tmp;
  }

  static int partition(int[] a, int l, int r) {
    // on suppose l < r i.e. au moins un élément
    int p = a[l], m = l;
    for (int i = l + 1; i < r; i++)
      if (a[i] < p)
        swap(a, i, ++m);
    // swap(a, l, m);
    return m;
  }

  static void quickrec(int[] a, int l, int r) {
    if (l >= r - 1)
      return;
    int m = partition(a, l, r);
    quickrec(a, l, m);
    quickrec(a, m + 1, r);
  }

  public void sort(int[] a) {
    quickrec(a, 0, a.length);
  }

}
